#ifndef _PLUGIN_INTERFACE_CONTAINER_H 
#define _PLUGIN_INTERFACE_CONTAINER_H_ 

#include <glib-object.h>
#include "bmpx/vfs.h"

#define BMP_TYPE_PLUGIN_CONTAINER_IFACE             (bmp_plugin_container_iface_get_type ())
#define BMP_PLUGIN_CONTAINER_IFACE(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_PLUGIN_CONTAINER_IFACE, BmpPluginContainerInterface))
#define BMP_PLUGIN_CONTAINER_IFACE_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), BMP_TYPE_PLUGIN_CONTAINER_IFACE, BmpPluginContainerInterfaceClass))
#define BMP_IS_PLUGIN_CONTAINER_IFACE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_PLUGIN_CONTAINER_IFACE))
#define BMP_IS_PLUGIN_CONTAINER_IFACE_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), BMP_TYPE_PLUGIN_CONTAINER_IFACE))
#define BMP_PLUGIN_CONTAINER_IFACE_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_INTERFACE ((inst), BMP_TYPE_PLUGIN_CONTAINER_IFACE, BmpPluginContainerInterfaceClass))


typedef struct _BmpPluginContainerInterface BmpPluginContainerInterface; 
typedef struct _BmpPluginContainerInterfaceClass BmpPluginContainerInterfaceClass;

struct _BmpPluginContainerInterfaceClass {
        GTypeInterface parent;

	gboolean    (*can_process)     (BmpPluginContainerInterface *self, const gchar *uri);

	gboolean    (*handle_set)      (BmpPluginContainerInterface *self, VFSHandle *handle);
	VFSHandle*  (*handle_get)      (BmpPluginContainerInterface *self);
	gboolean    (*handle_remove)   (BmpPluginContainerInterface *self);
	gboolean    (*handle_read)     (BmpPluginContainerInterface *self);

#if 0
	// NYI
	gboolean    (*handle_write)      (BmpPluginContainerInterface *self);
#endif

};

GType
bmp_plugin_container_iface_get_type (void);

gboolean
bmp_plugin_container_can_process (BmpPluginContainerInterface *self, const gchar *uri);

gboolean
bmp_plugin_container_handle_set (BmpPluginContainerInterface *self, VFSHandle *_handle);

VFSHandle*
bmp_plugin_container_handle_get (BmpPluginContainerInterface *self);

gboolean
bmp_plugin_container_handle_remove (BmpPluginContainerInterface *self);

gboolean
bmp_plugin_container_handle_read   (BmpPluginContainerInterface *self);


#endif /* _PLUGIN_INTERFACE_CONTAINER_H_ */











