#ifndef _PLUGIN_INTERFACE_FLOW_H 
#define _PLUGIN_INTERFACE_FLOW_H_ 

#include <glib-object.h>
#include "bmpx/list.h"

#define BMP_TYPE_PLUGIN_FLOW_IFACE             (bmp_plugin_flow_iface_get_type ())
#define BMP_PLUGIN_FLOW_IFACE(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_PLUGIN_FLOW_IFACE, BmpPluginFlowInterface))
#define BMP_PLUGIN_FLOW_IFACE_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), BMP_TYPE_PLUGIN_FLOW_IFACE, BmpPluginFlowInterfaceClass))
#define BMP_IS_PLUGIN_FLOW_IFACE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_PLUGIN_FLOW_IFACE))
#define BMP_IS_PLUGIN_FLOW_IFACE_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), BMP_TYPE_PLUGIN_FLOW_IFACE))
#define BMP_PLUGIN_FLOW_IFACE_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_INTERFACE ((inst), BMP_TYPE_PLUGIN_FLOW_IFACE, BmpPluginFlowInterfaceClass))


typedef struct _BmpPluginFlowInterface BmpPluginFlowInterface; 
typedef struct _BmpPluginFlowInterfaceClass BmpPluginFlowInterfaceClass;

struct _BmpPluginFlowInterfaceClass {
        GTypeInterface parent;

	BmpPlaybackHistoryItem* (*item_next)  (BmpPluginFlowInterface *self, const BmpListType *list, gint _idx);
	BmpPlaybackHistoryItem* (*item_prev)  (BmpPluginFlowInterface *self, const BmpListType *list, gint _idx);
};

GType
bmp_plugin_flow_iface_get_type (void);

BmpPlaybackHistoryItem*
bmp_plugin_flow_item_prev (BmpPluginFlowInterface *self, const BmpListType *list, gint _idx);

BmpPlaybackHistoryItem*
bmp_plugin_flow_item_next (BmpPluginFlowInterface *self, const BmpListType *list, gint _idx);

#endif /* _PLUGIN_INTERFACE_FLOW_H_ */











