#ifndef MAIN_H
#define MAIN_H

#include <config.h>

#ifdef HAVE_GUI
#include <bmp_ui.h>
#endif

#include <bmp_configuration.h>
#include <bmp_play.h>
#include <bmp_system_control.h>
#include <bmp_resource_manager.h>
#include <fam_monitor.h>
#include <gc.h>

#include "bmpx/playlist.h"

#define BMP_RCPATH		      ".bmpx"
#define BMP_SKIN_THUMB_DIR_BASENAME   ".thumbs"
#define BMP_SKIN_DIR_BASENAME         "skins"
#define BMP_CONFIG_BASENAME           "config.xml"
#define BMP_LOG_BASENAME              "log"
#define BMP_PLAYLISTS_DIR_BASENAME    "playlists"
#define BMP_METADATA_CACHE_BASENAME   "mcache.lcm"

#define BMP_UI_BASENAME		      "ui"
#define BMP_DATA_BASENAME	      "data"
#define BMP_IMAGES_BASENAME	      "images"
#define BMP_ICONS_BASENAME	      "icons/themes"
#define BMP_HTMLHELP_BASENAME	      "htmlhelp"


typedef enum {
    BMP_PATH_LOG_FILE,
    BMP_PATH_USER_DIR,
    BMP_PATH_USER_PLUGIN_DIR,
    BMP_PATH_USER_SKIN_DIR,
    BMP_PATH_SKIN_THUMB_DIR,
    BMP_PATH_ACCEL_FILE,
    BMP_PATH_CONFIG_FILE,
    BMP_PATH_PLAYLISTS,
    BMP_PATH_METADATA_CACHE,

    BMP_N_PATHS
} BmpApplicationPath;

extern gchar *bmp_paths[BMP_N_PATHS];

extern BmpResourceManager *bmp_rm;
extern BmpConfiguration   *bmp_configuration;
extern BmpPlaylist        *bmp_playlist;
extern BmpPlay		  *bmp_play;
extern BmpSystemControl   *bmp_system_control;
extern FamMonitor	  *bmp_fam_monitor;
#ifdef HAVE_GUI
extern BmpUI              *bmp_ui;
#endif
extern BmpMetadataCache   *bmp_metadata_cache;

extern NGC		  *ngc;

#ifndef HAVE_GUI
extern GMainLoop	  *mainloop;
#endif


#endif
